;const vector unsigned char fourPixelsToFourChannelsPerm = {0,4,8,12,1,5,9,13,2,6,10,14,3,7,11,15};
;vector unsigned char fourPixels;

;.align 15
;permFor4ColorTo4Channels: 0,4,8,12,1,5,9,13,2,6,10,14,3,7,11,15

.text
.globl _ppc_zoom_altivec2	;// name of the function to call by C program
.globl perm4ColorTo4ChannelsReverse
.globl perm4ColorTo4Channels

.data
.const
.align 7

perm4ColorTo4Channels:
.byte 6
.byte 4
.byte 8
.byte 12
.byte 1
.byte 5
.byte 9
.byte 13
.byte 2
.byte 6
.byte 10
.byte 14
.byte 3
.byte 7
.byte 11
.byte 15
perm4ColorTo4ChannelsReverse:
.byte 3,7,11,15,0,0,0,0,0,0,0,0,0,0,0,0

.data
.align 7

workVector:	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
coeffVector:	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.text
_ppc_zoom_altivec2:

mflr r10
addis r4,r10,ha16(perm4ColorTo4Channels-_ppc_zoom_altivec2)
la r3,lo16(perm4ColorTo4Channels-_ppc_zoom_altivec2)(r4)

;addis	r4,0,ha16(perm4ColorTo4Channels)
;lwz	r4,lo16(perm4ColorTo4Channels)(r4)

;li r3,67
;lbz r3,0(r4)
;lbz r3,(perm4ColorTo4ChannelsReverse)
;li r3,66

andi.	r3,r3,0xFF

blr

; vrsave !!!
li	r3,0xF
mtspr	256,r3

vspltish	v8, 0x8		; v8 rempli de 8 par demi-mots
vmuloub		v9, v8, v8	; v9 rempli de 64 par demi-mots
vspltisb	v10, 0xF	; v10 rempli de 0x0F par octets
vspltisb	v11, 0x01	; v11 rempli de 0x01 par octets
vspltisb	v12, 0x02	; v12 rempli de 0x02 par octets
vspltisb	v13, 0x03	; v13 rempli de 0x03 par octets
vspltisb	v14, 0x00	; v14 rempli de 0x00 par octets
vaddubs		v10, v10, v11	; v10 rempli de 0x10 par octets
vupkhsb		v10, v10	; v10 rempli de 0x10 par demi-mots
vslo		v10, v10, v8	; v10 rempli de 0x1000 par demi-mots
vupkhsb		v11, v11	;
vupkhsb		v12, v12	;
vupkhsb		v13, v13	;
vupkhsb		v14, v14	;
vsro		v12, v12, v9	;
vslo		v13, v13, v9	;
vor		v12, v12, v13	;
vor		v12, v12, v10	;
vsro		v14, v14, v9	;
vslo		v11, v11, v9	;
vor		v11, v11, v14	;
vor		v11, v11, v10	;

vaddubs		v13,v8,v8
vaddubs		v13,v13,v13	; v13 rempli de 32
vaddubs		v14,v9,v13	; v14 rempli de 96

addis	r11,0,ha16(_coeffs)		; chargement de _coeffs ->r11
lwz	r11,lo16(_coeffs)(r11)
addis	r15,0,ha16(_zoom_width)		; chargement de _ppcwidth ->r15
lwz	r15,lo16(_zoom_width)(r15)
mulli	r15,r15,4
addis	r16,0,ha16(_expix1)		; chargement de _ppcpix1 ->r16
lwz	r16,lo16(_expix1)(r16)
addis	r17,0,ha16(_expix2)		; chargement de _ppcpix2 ->r17
lwz	r17,lo16(_expix2)(r17)

mtspr	ctr,r10
li	r6,0
li	r9,0
li	r4,16
li	r10,0

1:			;boucle principale

lvx	v15, r9, r11
vslo	v15, v15, v13
vperm	v6,v15,v14,v12	; prep coef vector for col1 & col2
vperm	v3,v15,v14,v11	; prep coef vector for col3 & col4

lwzx	r19,r9,r11
add	r3,r19,r16
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v4,v0,v1,v2	; chargement de col1 et 2 ->v4
vupkhsb	v4,v4           ; unpack v4 (low ou high?)

add	r3,r3,r15
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v5,v0,v1,v2	; chargement de col3 et 4->v5
vupkhsb	v5,v5           ; unpack v5 (low ou high?)

vmuloub	v4,v6,v4
vmuloub	v5,v3,v5
vadduhs	v4,v4,v5
vslo	v5,v4,v9 ; shifter v4 de 64 bits a gauche et le coller dans v5
vadduhs	v4,v4,v5
vsrh	v4,v4,v8
vpkuhus	v4,v4,v4
vsro	v4,v4,v14
vslo	v7,v4,v14

;;;;;;;;;;;;;;;;;;;;;;;;;;
; Le pixel est calculé ! ;
;;;;;;;;;;;;;;;;;;;;;;;;;;

addi	r9,r9,8

vslo	v15, v15, v9
vperm	v6,v15,v14,v12
vperm	v3,v15,v14,v11

lwzx	r19,r9,r11
add	r3,r19,r16
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v4,v0,v1,v2	; chargement de col1 et 2 ->v4
vupkhsb	v4,v4           ; unpack v4 (low ou high?)

add	r3,r3,r15
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v5,v0,v1,v2	; chargement de col3 et 4->v5
vupkhsb	v5,v5           ; unpack v5 (low ou high?)

vmuloub	v4,v6,v4
vmuloub	v5,v3,v5
vadduhs	v4,v4,v5
vslo	v5,v4,v9	; shifter v4 de 64 bits a gauche et le coller dans v5
vadduhs	v4,v4,v5
vsrh	v4,v4,v8
vpkuhus	v4,v4,v4
vsro	v4,v4,v14
vslo	v4,v4,v9

;;;;;;;;;;;;;;;;;;;;;;;;;
vor	v7,v7,v4	; Le pixel est calculé !
;;;;;;;;;;;;;;;;;;;;;;;;;

addi	r9,r9,8

lvx	v15,r9,r11
vslo	v15, v15, v13
vperm	v6,v15,v14,v12
vperm	v3,v15,v14,v11

lwzx	r19,r9,r11
add	r3,r19,r16
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v4,v0,v1,v2	; chargement de col1 et 2 ->v4
vupkhsb	v4,v4           ; unpack v4 (low ou high?)

add	r3,r3,r15
lvx	v0,0,r3
lvx	v1,r4,r3
lvsl	v2,0,r3
vperm	v5,v0,v1,v2	; chargement de col3 et 4->v5
vupkhsb	v5,v5           ; unpack v5 (low ou high?)

vmuloub	v4,v6,v4
vmuloub	v5,v3,v5
vadduhs	v4,v4,v5
vslo	v5,v4,v9 ; shifter v4 de 64 bits a gauche et le coller dans v5
vadduhs	v4,v4,v5
vsrh	v4,v4,v8
vpkuhus	v4,v4,v4
vsro	v4,v4,v14
vslo	v4,v4,v13

;;;;;;;;;;;;;;;;;;;;;;;;;
vor	v7,v7,v4	; Le pixel est calculé !
;;;;;;;;;;;;;;;;;;;;;;;;;

addi	r9, r9, 8	; debut chargement des coeffs

vslo	v15, v15, v9
vperm	v6, v15,v14, v12	; extraction coeffs pour pix1 & pix2 dans v6
vperm	v3, v15,v14, v11	; extraction coeffs pour pix3 & pix4 dans v3

lwzx	r19, r9, r11	; debut chargement de pix1 et pix2 dans v4
add	r3, r19, r16	;
lvx	v0, 0, r3	;
lvx	v1, r4, r3	;
lvsl	v2, 0, r3	;
vperm	v4, v0, v1, v2	;
vupkhsb	v4, v4		; fin chargement de pix1 et pix2 dans v4

add	r3, r3, r15	; debut chargement de pix3 et pix4 dans v5
lvx	v0, 0, r3	;
lvx	v1, r4, r3	;
lvsl	v2, 0, r3	;
vperm	v5, v0, v1, v2	;
vupkhsb	v5, v5		; fin chargement de pix3 et pix4 dans v5

vmuloub	v4, v6, v4	; Multiplication par les coeffs (pix1 & pix2)
vmuloub	v5, v3, v5	; Multiplication par les coeffs (pix3 & pix4)
vadduhs	v4, v4, v5	; Addition des couches pix1 + pix3 et pix2 + pix4 dans v4
vslo	v5, v4, v9	; v5 = v4 << 8 octets
vadduhs	v4, v4, v5	; v4 = v4 + v5 soit ( (pix1+pix3) + (pix2+pix4) )
vsrh	v4, v4, v8	; v5[i] >> 1 octet (div de chaque composante par 8)
vpkuhus	v4, v4, v4	; package du pixel dans les 4 premiers octets
vsro	v4, v4, v14	; decalage du pixel en 4eme position

;;;;;;;;;;;;;;;;;;;;;;;;;
vor	v7,v7,v4	; Le pixel4 est calculé et copie dans la structure finale !
;;;;;;;;;;;;;;;;;;;;;;;;;

stvx	v7,r10,r17	; les 4 pixels sont copiés en ram

addi	r10,r10,16
addi	r9,r9,8
bdnz	1boucle		; c est fini pour quatre pixels on reboucle pour la suite

blr